/**
 * Implement a directed, weighted graph via an Adjacency Matrix
 * @author Mark Stehlik
 */

import java.io.*;
import java.util.*;

public class Graph
{
	// declare data here
	int numVertices;

    /**
     * Constructs a graph with 0 vertices and 0 edges
     */
    public Graph()
    {
	
    }


    /**
     * Constructs a graph with n vertices and 0 edges
     * @param n the number of vertices in the graph
     */
    public Graph(int n)
    {
	
    }
    
    
	/**
	 * Creates a new n x n adjacency matrix with n vertices and 0 edges
	 * @param n the number of vertices
	 */
	private void setSize(int n)
	{
	
	}
	
	
    /**
     * Constructs a graph from a file that obeys the following specification:
     * the first line contains the number of vertices (an int)
     * each subsequent line contains one edge stored as follows
     *    source, an int
     *    destination, an int
     *    and cost, a double
     * @param file a Buffered Reader connected to an opened file
     */
    public Graph(BufferedReader file) throws IOException
    {
		int source, dest;
		double cost;
		
		String line = file.readLine();
		numVertices = Integer.parseInt(line);
			
		setSize(numVertices);
		while ((line = file.readLine()) != null)
		{
			StringTokenizer sTok = new StringTokenizer(line);
			source = Integer.parseInt(sTok.nextToken());
			dest = Integer.parseInt(sTok.nextToken());
			cost = Double.parseDouble(sTok.nextToken());
			addEdge(source,dest,cost);
		}
		file.close();
    }
    

    /**
     * Returns the number of vertices
     * @return this graph's vertex count
     */
    public int getNumVertices()
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * Returns the number of edges
     * @return this graph's edge count
     */
    public int getNumEdges()
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * Returns true if an edge exists from origin to destination; false otherwise
     * @param origin the origin vertex
     * @param destination the destination vertex
     * @return boolean indicating the presence of edge [origin->destination]
     */
    public boolean hasEdge(int origin, int destination)
    {
		return false;    // dummy value to allow compilation
    }


    /**
     * Returns value of edge from origin to destination;
     * Returns NO_EDGE if no edge from origin to destination
     * @param origin the origin vertex
     * @param destination the destination vertex
     * @return value of edge [origin->destination], if present
     */
    public double edgeValue(int origin, int destination)
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * If no edge exists between origin and destination,
     *     increments edge count and stores new edge value
     * If edge already exists, replaces old cost with new value;
     *     does NOT increment number of edges in this case
     * @param origin the origin vertex
     * @param destination the destination vertex
     * @param value the edge value
     */
    public void addEdge(int origin, int destination, double value)
    {
	
    }


    /**
     * If edge exists between origin and destination,
     *     decrements edge count and stores NO_EDGE in adjacency matrix
     * If no edge exists, leaves NO_EDGE in adjacency matrix;
     *     does NOT decrement edge count in this case
     * @param origin the origin vertex
     * @param destination the destination vertex
     */
    public void removeEdge(int origin, int destination)
    {
	
    }


    /**
     * Returns a copy of the row of the adjacency matrix representing the
     * edges adjacent to (exiting) vertex v
     * @param v the start vertex
     * @return a copy of the edge-list from vertex v
     */
    public double[] getMyEdges(int v)
    {
		return null;    // dummy value to allow compilation
    }


    /**
     * Returns the number of edges with v as destination vertex
     * @param v the vertex
     * @return indegree of v
     */
    public int inDegree(int v)
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * Returns the number of edges with v as origin vertex
     * @param v the vertex
     * @return outdegree of v
     */
    public int outDegree(int v)
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * Returns the degree of vertex v
     * @param v the vertex
     * @return degree of v
     */
    public int degree(int v)
    {
		return 0;    // dummy value to allow compilation
    }


    /**
     * Returns a string representing this graph
     * @return this graph's string representation
     */
    public String toString()
    {
		return null;  // dummy value to allow compilation
    }
    
    
    public static void main(String[] args) throws IOException
    {
		Graph g = new Graph(5);
		g.addEdge(1,4,14.5);
		System.out.println("Vertex count = " + g.getNumVertices());
		System.out.println("Edge count = " + g.getNumEdges());
		System.out.println("Edge value (1->4) = " + g.edgeValue(1,4));
		System.out.println();
		System.out.println(g);
		
		Graph g2 = new Graph(new BufferedReader(new FileReader("graph.txt")));
		System.out.println(g2);
    }
}
